2008-12-29 (b558)
(+) Added alert when friends go offline.
(*) Lots of bug fixes, especially with multiplayer code.

2008-12-25 (b554)
(*) Critical bug fixes.
(*) Players quitting tag play don't cause the match to fail.

2008-12-25 (b552)
(+) New fully-flexible key binding system.
(+) New multiplayer game mode - Tag Play.
(+) New multiplayer VS win condition - Accuracy.
(+) Multiplayer performance is displayed on scoreboard.
(+) MSN and Yahoo status integration.
(+) Online rating can be seen on song selection screen.
(+) Custom and unlimited chat highlights trigger words.
(+) New skins!  Okami, Kakashi and ChronoCrosu.
(*) Updated skins! New versions of OEWY, Ouendan2 and Amigo, EliteBeatOsu.
(*) Performance improvements.
(*) Many bug fixes.

2008-12-12 (b543)
(+) New key binding system.  Please note any custom key bindings will be reset - please set them again in the Options menu.
(+) MSN integration.  Can be enabled from Online Options.
(*) Bug fixes.

2008-12-08 (b529)
(*) Bug fixes.

2008-12-07 (b528)
(+) Initial release of the Storyboard Editor.  Still missing some features, but the basics are there.
(+) New chat colours for BATs and subscribers.
(+) Added taiko barlines.
(*) Performance improvements (text rendering).
(*) Many bug fixes.

2008-11-17 (b505)
(+) 'Catch the Beat' rankings. Affects only playcount and total score (not ranked score). Note that this is in testing for one week, and scores MAY BE PURGED during this phase.
(+) Private Chat tabs. Keep track of your conversations better using /chat <user>.
(+) Friend online notifications. Be instantly notified when a friend signs in.
(+) Replay support (export, local) for all game modes reinstated.
(+) osu!direct pickup link improvements (forum links are handled smartly).
(+) Added toggle for spectator list display.
(+) 'Catch the Beat' with HardRock mod increases spacing between jumps where possible.
(+) osu! configuration is stored on a per-windows-user basis.
(*) Massive startup time improvements. You will only notice this from the second time you run this new build, as a new database structure must be created.
(*) Test mode improvements.
(*) Autoplay improvements.
(*) Many bugfixes.

2008-11-07 (b497)
(*) Bug fixes since major build.

2008-11-06 (b496)
(+) Friends list support in Extended Chat mode.  Add your friends and filter by them so you can easily see who is online!
(+) New game mode selection screen, and brand new game mode - 'Catch The Beat'.
(+) OpenGl support.  osu! will run on any system regardless of specs!
(+) osu!direct panel - get the most of your subscription with the ability to download beatmaps directly from a multiplayer game, spectating session, or the osu! chat window.  All without opening your browser.
(+) New offset wizard.  Uses the standardised tutorial to help you find your universal offset easier than before.
(+) First release of the official tutorial.  Available via osume, installer and offset wizard.
(+) Progress bar visible on the playfield.  Can adjust to three different positions.
(+) In-game FPS display option.
(+) Editor: Can copy timing information to clipboard (Ctrl+C at timing screen).
(+) Skinning: New skin colour options (for song selection text).
(+) New dialog while importing beatmaps.
(+) New Taiko HP increase formula.  A lot more authentic.
(*) Game will run at up to 1280x960.
(*) Mouse cursor is hidden when not being used.
(*) Smarter beatmap info refreshing and downloading.  Bandwidth consumed is a lot lower.
(*) Fix for bancho lag issues.
(*) HUGE performance increase (spinners, song title display, extended chat, song selection, video playback, beatmap importing).
(*) HalfTime nerf to 0.3x multiplier.
(*) Many editor improvements.
(*) Improved Autoplay and replay accuracy (should never miss now, except for on broken beatmaps).
(*) Increased 'passing' standard for O/X in break.
(*) Over 120 bug fixes.

2008-09-22 (b427)
(+) Added new sound sample 'clap'.
(*) Many post-release bug-fixes.

2008-09-21 (b426)
(+) osu!direct subscription service ready to go.  More details to come!
(+) Slider end-points can have individually chosen sample additions.
(+) Support for online offset adjustments/metadata reading.
(+) Added volume indicator when adjusting volume in play mode.
(+) Added UNRANKED graphic to notify player they are not being ranked.
(+) Progress bar and 'Jump To' dialog for main menu jukebox.
(+) Added song selection sort mode 'Rank'.
(+) New mod 'Spun Out'.
(+) New mod 'Autoplay'.  Support in editor test mode.
(+) Blue fire for combos over 500 hits.
(+) New skin: Lucky Star by Utena.
(*) Improvements to netcode.
(*) NoVideo mod works in multiplayer games.
(*) Taiko automatic conversion algorithm vastly improved.
(*) Replay accuracy improvements (especially on spinners).
(*) Many bug fixes, including a lot of multiplayer stability issues.

2008-09-03 (b413b)
(*) Spinner RPM calculation changes.
(*) Bug fixes.

2008-09-02 (b412)
(+) New mod 'Flashlight'.  The hardest way to play osu! yet.
(+) Timing points can inherit previous section's timing - useful for sample/volume changes.
(+) Skins can be auto-extracted.
(+) Ranking is displayed during break where possible.
(+) New layout for song selection screen.
(+) Personal online best can be seen in song selection and play-mode scoreboard, highlighted orange-red.
(+) Default skin improvements.
(+) Multiplayer host is denoted by a crown icon.  Can be transferred to another player on request.
(+) Combo burst images!
(+) New skinning elements.
(+) New chat commands.
(*) Bug fixes.
(*) Star physics improvements.
(*) Taiko hit-window is more lenient (about 40% moreso, depending on difficulty settings).
(*) Improved mp3 preview performance by a lot.
(*) Improved overall performance, especially at song selection.

2008-08-05 (b394a)
(*) Bug fixes.

2008-08-04 (b394)
(+) osu! can handle multiple monitors (experimental).
(+) Editor improvements (timing panel, seekbar, lock mode)
(+) Added Tags/Source metadata field to beatmaps. Can be searched but not viewed in-game yet.
(+) Taiko mode styling improvements.
(+) Multiplayer improvements (avatars, winner box, view users in room without joining, audio pause in setup, novideo actually works).
(+) Spinner upgrades (spin/clear sprites, rpm metre).
(+) Replay/spectator upgrades (taiko support, more accurate).
(+) Added new skin: Xi-Style by Xiaounlimited.
(*) Updated skin: taiko by LuigiHann (higher quality hit samples, new sprites!).
(*) Skin options screen changes.
(*) Slider click detection code improved (much more lenient to multi-button swapping).
(*) Huge memory optimisations.
(*) Relax mod revamped to remove all scoring, fail and ranking. Its totally relaxing now!
(*) Lots and lots of bug fixes.

2008-07-11 (b370)
(+) Taiko mod level up!  New game mechanics for almost all elements.  All that's left is taiko-specific scoring.  Replay/spectator does not yet work, but will soon.  Not sure how to play?  See http://osu.ppy.sh/forum/viewtopic.php?f=13&p=33569#p33569.
(+) New advanced editor options (quite limited and specific at the moment).
(+) Many graphical changes.
(+) Per-song custom offset (+/- keys during play mode).
(+) Extended chat improvements - level display and new colours.
(+) New layout for options menu.
(+) Highest online rank can be seen in song selection wheel.
(+) Custom keyboard binding support.
(+) Multiplayer replay export support.
(+) Sort by BPM.
(+) New Skin: osu! Ends With You (by awp).
(*) Chat console improvements. (/help)
(*) Editor improvements.
(*) Storyboarding improvements.
(*) Bug fixes galore.

2008-06-18
(*) Moving bancho.

2008-06-17 (b349)
(+) New match setup/lobby screen graphics.
(+) Client-side mods can be set on a per-client basis (currently just NoVideo).
(+) Notifications are given when a player joins/quits the game.
(+) Users can update a beatmap to the latest from the match setup screen.
(+) Multiplayer matches can perform a skip (all players must request this at the beginning of the song).
(+) Double-clicking an .osz file or dragging it into the osu! window while at Match Setup will handle the file without leaving the match.
(+) Added 'Folder' sort mode for song select.
(+) Added '/savelog' command to export chat logs.
(+) Multi-channel chat.
(*) Bug fixes and many other improvements.

2008-06-05 (b337)
(*) Multiplayer bug fixes.

2008-06-04 (b336)
(*) Multiplayer bug fix release.

2008-06-03 (b335)
(+) First release of multiplayer.
(+) New shader effects (enable them in options menu).
(+) New skinning options (animated sprites, sounds etc.)
(*) Hundreds of minor improvements (see changelog for full listing).

2008-05-26 (b320)
(*) Minor bug fixes.

2008-05-25 (b319)
(+) Many improvements to the skinning engine.
(+) New song selection physics.
(+) BSS improvements.
(+) New net library means people having problems should be able to use/update osu! as expected.
(+) In-play scoreboard.
(+) User panels display more detailed information.
(+) Piecewise/multipart bezier slider composition.
(+) Taiko Mod BETA.
(+) .osb file support (external storyboarding).
(+) New sound effects for default skin.
(+) Fire height adjustment.
(+) Private message support in chat '/msg <user> <message>'.
(+) Skin Ouendan2 by devkit4384 added to updater.
(*) Spectator scores are synchronised.
(*) Performance improvements.
(*) Many more errors are handled better.
(*) Editor improvements (too many to list).
(*) MILLIONS of bug fixes.

2008-04-28 (b291)
(+) Added highlight when your name is said.
(+) Points required until next rank added to ranking screen.
(+) New storyboard transformation type 'V' - vector scale.  Works like M but accepts width and height parameters for scaling a sprite, rather than movement.
(+) Added force tablet support option when automatic detection fails.
(+) User panels slide, sort and fade.
(+) Added mousewheel scrolling to user list.
(+) Added notification when you name is said in chat when chat is not open.
(+) Added option in song select to reset local scores for a particular beatmap.
(+) Beatmap submission status is displayed in editor song select.  Updating functionality is also present.
(*) Added now playing messages back in, but triggered by user command '/np'.
(*) HUGE optimisations to gameplay.  Around 16-18x faster (cpu) during gameplay.  Around 30% faster drawing sliders (including snaking).
(*) Moving sliders in editor (non-point editing) is around 95% faster.
(*) Play mode optimisations.  Some areas of code have improved in efficiency by up to 99.97%.  Parapara should be getting faster :P.
(*) Scroll lock key is blocked (xfire shortcut key).
(*) Converted all default skin sound samples to wav.  Removed silence-cutting from ALL mp3 samples.
(*) Skin template brought up-to-date.
(*) General editor improvements.
(*) Framerate limit disabling introduced again.
(*) Fixed many bugs.

2008-04-18 (b285)
(*) Rolling bug fixes.  Check development changelog for more information.

2008-04-17 (b283)
(*) Rolling bug fixes.  Required update for online scoring.

2008-04-16 (b282)
(!) Disabled framerate unlimiting for the time being.  Need to do a bit more testing.
(*) Critical bug-fixes.

2008-04-16 (b280)
(+) osu!Bancho online support is go!
(+) osu! loads replay files (.osr), and imports then to local ranking.  Can save any replay by hitting 'F2' at a ranking screen.
(+) Xfire compatibility/support added.
(+) When copying notes (Ctrl+C or editor menu), the clipboard will contain the current time location and combo numbers of selected notes (very useful for modding).
(+) Speed of countdown can be halved or doubled (Song Setup).
(+) Sliders snake in.
(+) New design for in-game chat/user display.
(+) Select in-game dialog buttons using number keys.
(+) Skinnable fonts.  Many new skinnable elements.
(+) Updates to EliteBeatOsu, Taiko and Ouendan1 skins (LuigiHann).
(+) Realtime user statistics updates (F9 online screen).
(+) Option to toggle skin samples on/off.
(+) Offset changes can be automatically reflected in hitobjects.
(+) Nickname tab completion support in chat mode.
(+) Fully recoded main menu with new button graphics, with icons kudos to LuigiHann.
(+) Automatic error report submission.
(+) Added hit accuracy statistics in editor test mode.  Should be useful for calculating incorrect offsets.
(+) Added displaying of city/country/localtime in F9 panel.
(+) Active mods are shown on the song selection screen.
(*) Huge default skin improvements.
(*) Total makeover for editor interface.
(*) Chat ticker can be toggled.
(*) Many new tooltips.
(*) Sliders look much cleaner - new border and gradient rendering.
(*) Performance improvements.
(*) Save local replay status is remembered.
(*) Mouse sensitivity doesn't affect editor.
(*) Allow for frame-unlimited gameplay.  Higher accuracy, smoothness and sensitivity.
(*) Fixed syncing accuracy of slower playback speeds in editor (<1x)
(*) Much much MUCH MUCH more.

2008-03-23 (b235)
(*) Fixed a few crippling bugs

2008-03-22 (b233)
(+) Replays can be imported and exported. osu! handles .osr files in a similar way to .osz.  You can export any previous replay by hitting F2 at the ranking screen.
(+) New online ranking dialog.
(+) New mod selection dialog.
(+) Skin selection screen.
(+) Changes in accuracy/ranked score/rank position display on user info panel.
(+) Links in chat are clickable.
(+) Added option to disable mouse buttons/wheel in gameplay.
(+) In-game web links accessible from editor and song selection screen (beatmap thread/info etc.).
(+) Added mod HalfTime.
(+) Animation support added to storyboarding.
(*) Various editor improvements.
(*) Changes to offset calculation.  Check your universal offset if things feel wrong.
(*) osu! default skin revamp.  Lots of changes to make things look generally cleaner.
(*) Various graphical improvements.
(*) Local scores database rewrite to make score/replay storage much more efficient.  Please note you will need to let osu! do a bit of maintenance on the first-run.
(*) New skin loading code.
(*) Greatly improved text render quality at 640x480 and 800x600.
(*) Bug fixes.

2008-03-10 (b222)
(+) Added a toggle to turn internal frame sync back on on the options screen.  Anyone experience newly-found lag - could you please try turning this on and report results?
(*) Bug fixes.

2008-03-09 (b221)
(+) Two new skins - PhoenixWright by Level-Up! and Noized by Fraeon.
(+) New Relax mod.
(+) Health bar recoveries added for Relax and EasyMode.
(+) Filter by ranked songs.
(+) New dialog system.
(+) New text renderer used in most parts of the game.
(+) F12 to screenshot gameplay.
(+) Maximum score/combo achievable is viewable in test mode.
(+) Main-menu tips.
(*) Over 80% improvement in video performance.  If you previously had video disabled due to lag, please try it again!
(*) Updated template skin with many new skinnable elements.
(*) Editor improvements.
(*) Many many bug fixes, and a few new bugs.
(*) New completely rewritten updater.
(*) Editor menu can be accessed using keyboard shortcuts (Alt-f-a etc.).
(*) Over 60% overall improvement in performance.
(*) Reduction of startup time by 40% on first load, 90% on subsequent loads.
(*) Keyboard control in song selection drastically improved.
(*) Storyboard scripting improvements.

2008-02-24 (b210)
(+) Added countdown sprites (thanks to LuigiHann).  Can be disabled on a per-beatmap basis.
(+) Added countdown audio samples (thanks to GuardianHX).
(+) Progress in titlebar during play.
(+) 'T' key taps in timing mode. 'R' key resets current timing section's timings.
(+) Sample volume can be set per beatmap/timing section.
(+) Tip of the day added into editor.
(+) Number of custom combo colours in rotation can be chosen (2-5).
(*) Timing Setup dialog redesign.
(*) Reorganisation of the song setup panel.

2008-02-16 (b197)
(*) Storyboarding bug fixes.
(*) EliteBeatOsu! v3 by LuigiHann updated.
(*) Pipe character spam in chat fixed.

2008-02-15 (b196)
(+) Storyboard support via manual scripting.
(+) FavouritesA and FavouritesB - two new filters for song selection.  Use popup menu/options menu to add and remove.
(+) Chat cursor location can be seen, as well as currently selected text.
(+) Right-click popup menu in song selection screen.
(+) Options menu lets you do similar operations to the popup menu, and also clear the unplayed beatmaps list (remove all unplayed).
(+) New game mods: HardRock (+6%), SuddenDeath and DoubleTime (+12%).
(+) Mouse wheel changes volume during play mode.
(+) Middle mouse button opens menu during play mode.
(*) Editor improvements.
(*) Bug fixes.

2008-02-04 (b188)
(+) Added two new skins (EliteBeatOsu! by LuigiHann and Shiruva by devkit4384).
(+) Section rankings - O or X is displayed at the end of each break (assuming the break is >3seconds).
(+) Added "My Maps" filter mode for edit song selection.  Only shows maps created by the currently logged user.
(+) Custom combo colouring can be setup in the song setup dialog.
(+) Background colour scripting (manual editing only).
(+) Currently spectating players are listed in play mode.
(*) BSS (Beatmap Submission System) improvements.
(*) Many editor enhancements/bug fixes.
(*) Random 100% cpu freezes fixed.
(*) osu! taking focus when hidden behind other windows fixed.
(*) Unplayed songs listing works once again.
(*) New more reliable net code.

2007-12-16 (b176)
(+) Circles are dimmed except for the next to-be-hit circle.
(+) General interface improvements.
(+) Date based sorting.
(+) New faster and more solid pUpdater system.
(*) Bug fixes.

2007-12-08 (b169)
(*) More complete tooltips.
(*) Many bug fixes.  See changelog for the specifics.
(+) New themes added (Holiday, NES and WindWaker).

2007-12-02 (b166)
(+) Basic tooltip support.
(+) Can drag-and-drop new beatmaps and new mp3 files into osu!.
(*) Fixes for some lag issues during gameplay with chat active.
(*) Fixed not being able to click away from rating properly (only on the buttons worked).
(*) Fixed slider placement problems while distance snapping is enabled.
(*) Local replays really work again this time.  Sorry.
(*) More bug fixes.

2007-11-28 (b164)
(*) Bug fixes.

2007-11-26 (b162)
(*) Major improvements on spectator score/play accuracy.
(*) Toggle buttons on chat dialog now don't change text.  This was confusing apparently!
(*) Fixed scoring bug where combo went higher than it should.
(*) Fixed offline replays not playing back.
(*) /quit in chat mode also closes chat panel. 
(*) System generated chat messages are not added to message history.
(*) Changing usename while chat is open disconnects from chat.
(*) Spaces are replaced with %20s in the download text field in upload dialog.
(*) Changing the sampleset can be done without an initial save of old files.
(*) Default sampleset option in song setup screen affects all timing points if they all have same (default) settings.
(*) Creator field is locked to logged-in username.
(*) Spinner approach circle hidden in hidden mode.
(*) Increased network connection pool and added stronger error handling.
(*) IRC usernames are enforced to be valid.
(*) Playing offline does not cause errors to appear.
(*) Auto-hiding of chat works better with pause mode.
(*) Play button on main menu unpauses when music is already paused.

2007-11-25 (b160)
(+) New timing control screen.
(+) osu! associates itself with .osz files, and can load them by double-clicking a beatmap file directly!
(+) Samplesets can be defined per timing section.
(+) In-game song rating system.
(+) Time signature support added.
(+) Replay control buttons.
(+) Auto chat login/hiding.
(+) Audio controls on main menu.
(+) Full chat mode & Spectator mode.
(+) Ghost S/SS rankings (for hidden mode achievements).
(*) eyupstars v1.1 (currently in osu! only - no web support).
(*) Editor improvements all-round.
(*) New icons to show what status a beatmap has in song selection.
(*) Many improvements to gameplay accuracy.
(*) Many many many many many bug fixes.
(*) Fixed slider tick PC reboot bug.

2007-11-14 (b144)
(+) Skins can skin soft/loud soundsets separately (ask me for now, will update post later).
(+) Can move threads from WIP to completed from the upload dialog.
(+) New mods: Hidden (+6%) and NoVideo (no effect).
(+) Accuracy added to in-game results screen.
(+) Double-clicking on a note in the gamefield/timeline in editor seeks to that point in time.
(+) Large editor improvements (see last 4 days of changelog for details).
(*) Fixed dodginess with upload system.
(*) Fixed soft sampleset slider loop not looping properly.
(*) GPU load reduced by almost half in play/edit modes.
(*) Sharpened and recreated all editor side-tab sprites.
(*) Fixed avatars where width is greater than height.
(*) Fixed editor resolution change not resizing the black overlay area.
(*) Fixed "load thread after submit" not doing anything.
(*) Select All forces 'selection' tool.
(+) Web: Ranking support added to new submission system!  Should make the mod's job easier :).

2007-11-10 (b140)
(!) Sorry about the extra new version - just fixing a few submission things before people get in a mess!
(+) Many chat improvements.
(+) New layout for selection screen options.
(+) Beatmap submission support! (File > Upload Beatmap..)
(*) HUGE optimisations to code.  Should notice a performance increase.
(*) Bug fixes.  See changelog on web for all the details which aren't included in this list.  There's lots.

2007-11-04 (b130)
(+) Added 'SS' ranking (ALL300).
(+) Added basic test mode statistics.
(+) Slider tick rate of 3 allowable (3/8, 6/8, 12/8 kinds of timings).
(+) Spinner sounds are customisable.
(+) Sounds can be loaded from a skin directory.
(+) Added 'retry' button on ranking screen.
(+) Support for quit (/quit) in chat.
(*) Huge improvements to audio sample handling.
(*) Much better handling of dropped/failed connections for chat.
(*) Videos scale based on width instead of height.
(*) Bug fixes.

2007-11-03 (b129)
(+) Userlist for chat.
(+) Support for actions (/me) in chat.
(*) Chat ticker fades faster in editor (gets annoying otherwise).
(*) Keyboard layouts fixed for chat.
(*) Fixed missing last note causing failure.
(*) Chat gracefully quits.

2007-11-01 (b128)
(+) Basic chat support.
(+) User stats on main menu.
(*) Shrunk osu! on song selection screen.
(*) Fixed crash when typing 'osu' into search in play mode with unmapped mp3s present.
(*) Mouse cursor is visible when error dialog pops up.
(*) No longer bothers to submit scores when the song isn't rankable.
(*) Fixed potential bug where audio ends less than the fadeout interval after the last note.
(*) Fixed accuracy displaying as huge numbers for different localities.

2007-10-31 (b127)
(+) New star rating system courtesey of eyup!  Check out the in-game star ratings.
(+) New main menu/selection effects and "Now Playing" display added.
(+) Search shows match count.
(+) Search auto-selects when refined to 1 song.
(+) Song lead-in for beatmaps starting very early in the mp3.
(+) Item counts for folders.
(+) Displaying song length.
(*) Menu songs loop correctly.
(*) Search mode efficiency improved greatly.
(*) Search query reset when changing tabs.
(*) Pointer restrictions are much more precise.
(*) Many bug fixes.

2007-10-29 (b125)
(+) Shift+1-8 changes divisor.
(+) Ctrl+Mousewheel changed to adjust divisor.
(*) Replaced search tab with 'All'.
(*) Default sort mode is now 'All'.
(*) Slider snap divisor set back to how it should be (not normal divisor/2).
(*) Fixed login entry dialog not disappearing correctly.
(*) Fixed slider accuracy.

2007-10-29 (b123)
(+) Bookmarks display in timeline.
(+) Added user stats to song selection screen.
(*) Can skip in replay by hitting 'Space'.
(*) Sorting improvements.
(*) Editor bug fixes.

2007-10-28 (b121)
(+) Sorting engine implemented.
(+) Full dynamic song searching!
(+) Mouse is restricted to window during gameplay.
(+) 'Alt' distance-based snapping can be adjusted via Alt+MouseWheelUp/MouseWheelDown.
(+) Difficulty stars increase in halves.
(+) 'Unplayed songs' folder added to sorting.
(+) Skin preview added to options screen.
(*) Mousewheel seeks by default.  Holding 'Ctrl' changes placement controls.
(*) Skin template updated.  Added comments, readme and new sprites.
(*) Bug fixes.

2007-10-26 (b114)
(*) Fixed duplicates in local high-score entries.
(*) Bug fixes.

2007-10-25 (b113)
(+) New skinning options!
(+) Many editor changes.
(+) Keyboard gameplay controls (z,x,ctrl,spacebar).
(*) Spiners regenerate more HP.
(*) Sliders penalise less.
(*) Huge performance increase on song selection screen.

2007-10-24
(+) Three new official skins available!

2007-10-22 (b110)
(+) Play-testing mode in editor.
(+) Recalculate slider lengths option in editor.
(+) iDork skin by Fraeon added to extras.
(*) Full TabletPC support.
(*) Exiting and crashing handled better.

2007-10-20 (b107)
(*) Updates to song selection dynamics.
(*) Bugfix for huge editor lag.
(*) Fixed replay data not saving correctly.

2007-10-19 (b106)
(*) Urgent bugfix - updating non-ranked songs was deleting the beatmap.

2007-10-18 (b105)
(+) Ability to update ranked osu files from in-game.
(+) Per-beatmap skinning (see changelog for details).
(*) Many bug fixes.

2007-10-16
(+) New editor features (position snapping/slider speed preview).
(*) Bug fixes.

2007-10-14
(*) Scoring bug fixed.

2007-10-13
(+) New sounds + soft sampleset.
(*) Removed "KYLECITOISTHEGREATESTONTHEWORLD" cheat code.
(*) Yes that was a joke..
(*) Bug fixes.

2007-10-11
(+) New updater.
(+) Skinning support.
(+) Editor additions.
(*) Many bug fixes.

2007-10-08
(*) Fixed edit mode bugs.

2007-10-07
(+) Online ranking in-game.
(+) New features and bug fixes.  See forums for further details.
(!) Skinning support held back until next release.

2007-10-06
(*) Critical bug fixes.

2007-10-05
(+) Major release. See forum post for details (will be up soon).

2007-09-30 (b86)
(+) New editor features.
(*) Minor bug fixes.

2007-09-29 (b78)
(!) Fixed sliders not displaying for some people.  Woot.
(*) Minor bug fixes.

2007-09-28
(+) Editor enhancements.
(+) General new features.
(*) Bug fixes.

2007-09-27
(*) HUGE list of bug fixes.

2007-09-26
(+) Basic framework for break/intermission periods.
(*) Many more bug fixes. (see changelog thread for details)

2007-09-25
(+) Offset can be set for audio.
(*) Minor bug fixes and tweaks.

2007-09-24
(+) Play mode mods.
(+) New features as requested in forums.  See <a href="http://osu.ppy.sh/forum/viewtopic.php?f=2&t=15&start=10">changelog</a> thread for full details.
(*) Many many many bug fixes!

2007-09-20
(*) Some crazy bug fixes.
(*) Changes to gameplay to emulate ouendan more closely.
(*) Hopefully fixed bug with unsupported characters.

2007-09-19
(+) New straight line curve type.
(+) osu! knows when it needs an update.
(*) Bug fixes.

2007-09-18
(*) Minor bug fixes.
(*) Changes to directory and filename standards.

2007-09-17
(+) Song grouping.
(*) Difficulty toned down drastically.
(*) Minor bug fixes.

2007-09-16
(!) First internal beta release!
(*) Small update fixes video errors and a few other minor bugs reported.
(*) Reduced brightness of screen flashes on selection.
(*) Made easy mode a bit easier.